python基础知识之try...except...的详细用法实例

python基础知识之try...except...的详细用法实例

前言

我们把可能发生错误的语句放在try模块里,用except来处理异常。except可以处理一个专门的异常,也可以处理一组圆括号中的异常,如果except后没有指定异常,则默认处理所有的异常。每一个try,都必须至少有一个except

1.异常类只能来处理指定的异常情况,如果非指定异常则无法处理

s1 = "hello"
try:
    int(s1)
except IndexError as e: # 未捕获到异常,程序直接报错
    print (e)

2.多分支

s1 = "hello"
try:
    int(s1)
except IndexError as e:
    print(e)
except KeyError as e:
    print(e)
except ValueError as e:
    print(e)

3.万能异常Exception

s1 = "hello"
try:
    int(s1)
except Exception as e:
    print(e)

4.多分支+Exception

s1 = "hello"
try:
    int(s1)
except IndexError as e:
    print(e)
except KeyError as e:
    print(e)
except ValueError as e:
    print(e)
except Exception as e:
    print(e)

5.异常的其他机构(try…finally语法)

try…finally语句无论是否发生异常都将会执行最后的代码。

语法如下:

try:
<语句>
finally:
<语句>    #退出try时总会执行
raise

示例:

s1 = "hello"
try:
    int(s1)
except IndexError as e:
    print(e)
except KeyError as e:
    print(e)
except ValueError as e:
    print(e)
#except Exception as e:
#    print(e)
else:
    print("try内代码块没有异常则执行我")
finally:
    print("无论异常与否,都会执行该模块,通常是进行清理工作")

6.主动触发异常(raise语句)

我们可以使用raise语句自己触发异常,raise语法格式如下:

raise [Exception [, args [, traceback]]]

语句中Exception是异常的类型(例如,NameError)参数是一个异常参数值。该参数是可选的,如果不提供,异常的参数是"None"。

最后一个参数是可选的(在实践中很少使用),如果存在,是跟踪异常对象。

示例:

一个异常可以是一个字符串,类或对象。 Python的内核提供的异常,大多数都是实例化的类,这是一个类的实例的参数。

定义一个异常非常简单,如下所示:

def functionName( level ):
    if level < 1:
        raise Exception("Invalid level!", level)
        # 触发异常后,后面的代码就不会再执行        
try:
    raise TypeError("类型错误")
except Exception as e:
    print(e)

7.自定义异常

通过创建一个新的异常类,程序可以命名它们自己的异常。异常应该是典型的继承自Exception类,通过直接或间接的方式。

以下为与BaseException相关的实例,实例中创建了一个类,基类为BaseException,用于在异常触发时输出更多的信息。

在try语句块中,用户自定义的异常后执行except块语句,变量 e 是用于创建Networkerror类的实例。

class Networkerror(BaseException):
    def __init__(self,msg):
        self.msg=msg
    def __str__(self):
        return self.msg
 
try:
    raise Networkerror("类型错误")
except Networkerror as e:
    print(e)

8.断言:assert条件

assert 1 == 1 
assert 1 == 2

9.总结try…except

  • 把错误处理和真正的工作分开来
  • 代码更易组织,更清晰,复杂的工作任务更容易实现
  • 毫无疑问,更安全了,不至于由于一些小的疏忽而使程序意外崩溃了

补充:多重try

如果是嵌套的try...except...的话,这一层raise的错误,会被上一层的try...except...进行捕获

总结

到此这篇关于python基础知识之try...except...详细用法的文章就介绍到这了,更多相关python try...except...详细用法内容请搜索云海天教程以前的文章或继续浏览下面的相关文章希望大家以后多多支持云海天教程!

原文地址:https://blog.csdn.net/qdPython/article/details/121539451